* PRISMOD MODEL - dopris0_master.do *
* Libor Dusek, Jan Vavra, Paolo Buonanno
** more info in dopris0_readme.do

* COMBINES TWO PARAFILES, THEN RUNS THE MODEL AND PLOTS MODELFIT *
clear
set more off
global pcent "100" 
******* SETTINGS *******************
* Define 1st parafile
local parafile1="2006arima_A1M2_f"
** ! technical variables are kept from 1st file !!
** paramethers taken from 1st parafile
	local para_from1="c1"
* Define 2nd parafile
local parafile2="base"
	local para_from2="p1 z1 z2 p2 z3 p3 p4 p_a1 p_a2 s_hs s_ls p4_hs lc la1 la2 la3 p5 pe_a3 pe_o pe_hsls p_z4 s_a1 s_a2 s_a3 vr_a1 vr_a2 vr_a3"
** paramethers taken from 2nd parafile
************************************
* list of all para c1 p1 z1 z2 p2 z3 p3 p4 p_a1 p_a2 s_hs s_ls p4_hs lc la1 la2 la3 p5 pe_a3 pe_o pe_hsls p_z4 s_a1 s_a2 s_a3 vr_a1 vr_a2 vr_a3

* 1. Create parafile from merged parafiles
** create new folder, delete old if present
!rmdir simulations_100\\comb_`parafile1'_`parafile2'  /s /q
capture mkdir simulations_100\\comb_`parafile1'_`parafile2'

** check if all paramethers are present, if not, produce error and print reason
	quietly {
	local allparalist= "c1 p1 z1 z2 p2 z3 p3 p4 p_a1 p_a2 s_hs s_ls p4_hs lc la1 la2 la3 p5 pe_a3 pe_o pe_hsls p_z4 s_a1 s_a2 s_a3 vr_a1 vr_a2 vr_a3"
	* create new local as concat of defined lists
	local test_ofallpara `"`para_from1' `para_from2'"'
	* test if its equal to all para varlist
	local allparatest: list allparalist === test_ofallpara
	* if not, find out what happended, produce error, stop execution
	if  `allparatest'==0 {
	* para can be missing
	** all para = 29 paramethers
	local para_n: list sizeof test_ofallpara
	if `para_n'!=28 {
		if `para_n'<28 {
			local missing_para: list allparalist - test_ofallpara
			noisily display as error "paramethers `missing_para' are missing!!"
		}
		if `para_n'>28 {
			noisily display as error "too many paramethers!!"
		}
	}
	* para can be duplicate
	local duplic: list dups test_ofallpara
	if  "`duplic'"!=""{
		noisily display as error "duplicates: `duplic'"
		}
	* there can be a typo
	local uniq_para: list uniq test_ofallpara
	local typotest: list uniq_para - allparalist 
	if  "`typotest'"!=""{
		noisily display as error "unknown pars: `typotest'"
		}
	* stop execution	
	exit
	}
	* end quietly
	}
** merge parafiles
** ! technical variables are kept from 1st file !!
use simulations_100\\`parafile1'\\`parafile1'_paramavg_100.dta 
drop `para_from2'
sort oca q
save simulations_100\\comb_`parafile1'_`parafile2'\\comb_`parafile1'_`parafile2'_paramavg_100.dta, replace 
use simulations_100\\`parafile2'\\`parafile2'_paramavg_100.dta 
keep oca q `para_from2'
sort oca q
merge 1:1 oca q using simulations_100\comb_`parafile1'_`parafile2'\comb_`parafile1'_`parafile2'_paramavg_100.dta
drop _merge
save simulations_100\\comb_`parafile1'_`parafile2'\comb_`parafile1'_`parafile2'_paramavg_100.dta, replace 

* 2. Run the model and plot the result
quietly do dopris3_modelavg
pminflowsimul comb_`parafile1'_`parafile2'
	
quietly do dopris4_descriptive
paraplot comb_`parafile1'_`parafile2'
modelfit comb_`parafile1'_`parafile2'
	
